###################################################
###################################################
# split output file at each taxonomic level
###################################################
###################################################

suppressPackageStartupMessages(library("optparse"))
suppressPackageStartupMessages(library("futile.logger"))

# make options list
option_list <- list(
               make_option(c("-i", "--infile"), default=NA, type="character",
                           help="input data table from dada2 pipeline [default %default]"),
               make_option(c("--outdir"), default="abundance.dir",
                           help="output for files [default %default]"))

# suppress warning messages
options(warn=-1)

###########################
# get command line options
###########################
opt <- parse_args(OptionParser(option_list=option_list))

buildPerLevelTable <- function(taxa_abundances, level="phylum"){

		   possible.levels = c("phylum",
		   		       "class",
				       "order",
				       "family",
				       "genus",
				       "species")
			
		   if (level %in% possible.levels){
		       if (level == "phylum"){
           		   p <- gsub(";c__.*", "", rownames(dat))
		           p <- gsub("ASV[0-9]*:", "", p)
   		           d <- aggregate(dat, by=list(p), sum)}
                       else if (level == "class"){
			   c <- gsub(";o__.*", "", rownames(dat))
  		           c <- gsub("ASV[0-9]*:", "",  c)
                           d <- aggregate(dat, by=list(c), sum)}
                       else if (level == "order"){
                           o <- gsub(";f__.*", "", rownames(dat))
		           o <- gsub("ASV[0-9]*:", "",  o)
                           d <- aggregate(dat, by=list(o), sum)}
		       else if (level == "family"){
                           f <- gsub(";g__.*", "", rownames(dat))
		           f <- gsub("ASV[0-9]*:", "",  f)
                           d <- aggregate(dat, by=list(f), sum)}
		       else if (level == "genus"){
		           g <- gsub(";s__.*", "", rownames(dat))
		           g <- gsub("ASV[0-9]*:", "",  g)
                           d <- aggregate(dat, by=list(g), sum)}
		       else if (level == "species"){
		           s <- gsub(".*;", "", rownames(dat))
		           g <- gsub(";s__.*", "", rownames(dat))
		           g <- gsub("ASV[0-9]*:", "",  g)
			   s <- paste(g, s, sep=";")
                           d <- aggregate(dat, by=list(s), sum)}
                   }
		   else{
		   stop("level not one of phylum, class, order, family, genus, species")
		   }
		   colnames(d)[colnames(d) == "Group.1"] <- "Taxon"
		   return(d)
		   }

dat <- read.csv(opt$`infile`, header=T, stringsAsFactors=F, sep="\t", row.names=1, quote="")

flog.info("writing per level tables")
p <- buildPerLevelTable(dat, level="phylum")
outfile <- paste(opt$`outdir`, "phylum_abundance.tsv", sep="/")
write.table(p, file=outfile, sep="\t", quote=F, row.names=F)

c <- buildPerLevelTable(dat, level="class")
outfile <- paste(opt$`outdir`, "class_abundance.tsv", sep="/")
write.table(c, file=outfile, sep="\t", quote=F, row.names=F)

o <- buildPerLevelTable(dat, level="order")
outfile <- paste(opt$`outdir`, "order_abundance.tsv", sep="/")
write.table(o, file=outfile, sep="\t", quote=F, row.names=F)

f <- buildPerLevelTable(dat, level="family")
outfile <- paste(opt$`outdir`, "family_abundance.tsv", sep="/")
write.table(f, file=outfile, sep="\t", quote=F, row.names=F)

g <- buildPerLevelTable(dat, level="genus")
outfile <- paste(opt$`outdir`, "genus_abundance.tsv", sep="/")
write.table(g, file=outfile, sep="\t", quote=F, row.names=F)

s <- buildPerLevelTable(dat, level="species")
outfile <- paste(opt$`outdir`, "species_abundance.tsv", sep="/")
write.table(s, file=outfile, sep="\t", quote=F, row.names=F)

###################################################
###################################################
# Error model, de-replication and sample inference
###################################################
###################################################

suppressPackageStartupMessages(library("optparse"))
suppressPackageStartupMessages(library("dada2"))
suppressPackageStartupMessages(library("ggplot2"))
suppressPackageStartupMessages(library("futile.logger"))

# make options list
option_list <- list(
               make_option(c("--filtF"), default=NA, type="character",
                           help="filtered forward fastq file [default %default]"),
               make_option(c("--filtR"), default=NA, type="character",
                           help="filtered reverse fastq file [default %default]"),
	       make_option(c("-n", "--nbases"), default=10000000,
                           help="number of reads to learn error model [default %default]"),
	       make_option(c("--omega-a"), default=1e-40,
                           help="p-value for new clusters [default %default]"),
	       make_option(c("--use-quals"), default=TRUE,
                           help="If TRUE, the dada(...) error model takes into account
                           the consensus quality score of the dereplicated unique sequences.
                           If FALSE, quality scores are ignored. Default is TRUE.
                           [default %default]"),
               make_option(c("--use-kmers"), default=TRUE,
                           help="If TRUE, a 5-mer distance screen is performed prior to
                           performing each pairwise alignment, and if the 5mer-distance is
                           greater than KDIST_CUTOFF, no alignment is performed. Default is
                           TRUE. [default %default]"),
	       make_option(c("--kdist-cutoff"), default=0.42,
                           help="The default value of 0.42 was chosen to screen pairs
                           of sequences that differ by >10%, and was calibrated on Illumina
                           sequenced 16S amplicon data. The assumption is that sequences that
                           differ by such a large amount cannot be linked by amplicon errors
                           (i.e. if you sequence one, you won't get a read of other) and so
                           careful (and costly) alignment is unnecessary. [default %default]"),
	       make_option(c("--band-size"), default=16,
                           help="When set, banded Needleman-Wunsch alignments are
                           performed. Banding restricts the net cumulative number of
                           insertion of one sequence relative to the other. The default value
                           of BAND_SIZE is 16. If DADA is applied to marker genes with high
                           rates of indels, such as the ITS region in fungi, the BAND_SIZE
                           parameter should be increased. Setting BAND_SIZE to a negative
                           number turns off banding (i.e. full Needleman-Wunsch). [default %default]"),
	       make_option(c("--gap-penalty"), default=-8,
                           help="The cost of gaps in the Needleman-Wunsch alignment.
                           Default is -8.[default %default]"),
	       make_option(c("--homopolymer-gap-penalty"), default=NULL,
                           help="The cost of gaps in homopolymer regions
                          (>=3 repeated bases). Default is NULL, which causes homopolymer
                          gaps to be treated as normal gaps. [default %default]"),
	       make_option(c("--min-fold"), default=1,
                           help="The minimum fold-overabundance for sequences to form new
                           clusters. Default value is 1, which means this criteria is
                           ignored.[default %default]"),
               make_option(c("--min-hamming"), default=1,
                           help="minimum hamming distance to define new cluster [default %default]"),
               make_option(c("--min-abundance"), default=1,
                           help="The minimum abundance for unique sequences form new
                           clusters. Default value is 1, which means this criteria is
                           ignored.[default %default]"),
               make_option(c("--max-clust"), default=0,
                           help="The maximum number of clusters. Once this many clusters
                           have been created, the algorithm terminates regardless of whether
                           the statistical model suggests more real sequence variants exist.
                           If set to 0 this argument is ignored. Default value is 0.[default %default]"),
               make_option(c("--max-consist"), default=10,
                           help="The maximum number of steps when selfConsist=TRUE. If
                           convergence is not reached in MAX_CONSIST steps, the algorithm
                           will terminate with a warning message. Default value is 10.
                           [default %default]"),
               make_option(c("--filter"), default=0,
                           help="filter sequences out if (n0+n1)/abundance < --filter. This hopes to remove
                           spurious sequences that are a partition that contains sequences with few true
                           matches [default %default]"),
               make_option(c("-o", "--outdir"), default=".",
                           help="output directory - name will be based on file name [default %default]")
			   )

# suppress warning messages
options(warn=-1)

###########################
# get command line options
###########################

opt <- parse_args(OptionParser(option_list=option_list))

# get sample name
sample.name <- gsub(".fastq.1.gz", "", basename(opt$`filtF`))

# check that filtF is specified
if (is.na(opt$`filtF`)){
   stop("--filtF parameter must be provided. See script usage (--help)")
   }

directory <- dirname(opt$`filtF`)

###########################################################################
# learn errors and do sample inference - separates out for paired-end or
# single end at the moment although this could probably be refactored in
# the future
###########################################################################

flog.info(gsub("nbases", as.character(opt$`nbases`), "learning errors on the first nbases bases"))

if (is.na(opt$`filtR`)){

   # error model inference
   errF <- learnErrors(opt$`filtF`, multithread=FALSE, nbases=opt$`nbases`)
   flog.info("plotting error model")
   p <- plotErrors(errF, nominalQ=TRUE)
   filename <- paste(paste(directory, sample.name, sep="/"), "errF.png", sep="_")
   ggsave(filename, type="cairo")

   # dereplication
   flog.info("dereplication")
   derepF <- derepFastq(opt$`filtF`, verbose=TRUE)

   # sample inference
   flog.info("sample inference")	
   dadaF <- dada(derepF,
                 err=errF,
		 multithread=FALSE,
		 OMEGA_A=opt$`omega-a`,
		 USE_QUALS=opt$`use-quals`,
		 USE_KMERS=opt$`use-kmers`,
		 KDIST_CUTOFF=opt$`kdist-cutoff`,
		 BAND_SIZE=opt$`band-size`,
		 GAP_PENALTY=opt$`gap-penalty`,
		 HOMOPOLYMER_GAP_PENALTY=opt$`homopolymer-ga-penalty`,
		 MIN_FOLD=opt$`min-fold`,
                 MIN_HAMMING=opt$`min-hamming`,
                 MIN_ABUNDANCE=opt$`min-abundance`,
		 MAX_CLUST=opt$`max-clust`,
		 MAX_CONSIST=opt$`max-consist`
                 )

   # return a dataframe - I find this more intuitive
   dadaF.df <- as.data.frame(dadaF$denoised)
   dadaF.df$sequence <- rownames(dadaF.df)
   dadaF.df <- data.frame(sequence=dadaF.df$sequence, abundance=dadaF.df[,1])

   # get diagnostic clustering data frame
   df.clustering <- dadaF$clustering
   clustering.filename <- paste0(opt$`outdir`, "/", sample.name, "_clustering.tsv")
   write.table(df.clustering, clustering.filename, sep="\t", row.names=FALSE)

   # filtering options
   sequences.to.keep <- df.clustering$sequence[(df.clustering$n0 + df.clustering$n1)/df.clustering$abundance >= opt$`filter`]
   dadaF.df <- dadaF.df[dadaF.df$sequence %in% sequences.to.keep,]

   # remove chimeras
   flog.info("removing chimeric sequences")
   dadaF.df.nochim <- removeBimeraDenovo(dadaF.df, method="consensus")

   # write out table
   flog.info("writing results")
   outfile <- paste(opt$`outdir`, sample.name, sep="/")
   outfile <- paste(outfile, "_seq_abundance.tsv", sep="")
   write.table(dadaF.df.nochim, file=outfile, sep="\t", quote=F, row.names=F)

   # write summaries
   # get summaries of reads passing each stage
   flog.info("writing summaries")
   getN <- function(x) sum(getUniques(x))
   track <- data.frame(cbind(getN(dadaF), getN(dadaF.df.nochim)))
   colnames(track) <- c("denoisedF", "nonchim")
   track$sample <- sample.name

   summary.outfile <- paste(opt$`outdir`, sample.name, sep="/")
   summary.outfile <- paste(summary.outfile, "_summary.tsv", sep="")
   write.table(track, summary.outfile, sep="\t", row.names=F)


} else {

   # error model learning
   errR <- learnErrors(opt$`filtR`, multithread=FALSE, nbases=opt$`nbases`)
   errF <- learnErrors(opt$`filtF`, multithread=FALSE, nbases=opt$`nbases`)

   flog.info("plotting error model")
   p <- plotErrors(errF, nominalQ=TRUE)
   filename <- paste(paste(directory, sample.name, sep="/"), "errF.png", sep="_")
   ggsave(filename, height=10, width=10, type="cairo")
   p <- plotErrors(errR, nominalQ=TRUE)
   filename <- paste(paste(directory, sample.name, sep="/"), "errR.png", sep="_")
   ggsave(filename, type="cairo")

   # dereplication
   flog.info("dereplication")
   derepF <- derepFastq(opt$`filtF`, verbose=TRUE)
   derepR <- derepFastq(opt$`filtR`, verbose=TRUE)

   # sample inference
   flog.info("sample inference")
   dadaF <- dada(derepF,
                 err=errF,
		 multithread=FALSE,
		 OMEGA_A=opt$`omega-a`,
		 USE_QUALS=opt$`use-quals`,
		 USE_KMERS=opt$`use-kmers`,
		 KDIST_CUTOFF=opt$`kdist-cutoff`,
		 BAND_SIZE=opt$`band-size`,
		 GAP_PENALTY=opt$`gap-penalty`,
		 HOMOPOLYMER_GAP_PENALTY=opt$`homopolymer-ga-penalty`,
		 MIN_FOLD=opt$`min-fold`,
                 MIN_HAMMING=opt$`min-hamming`,
                 MIN_ABUNDANCE=opt$`min-abundance`,
		 MAX_CLUST=opt$`max-clust`,
		 MAX_CONSIST=opt$`max-consist`)

   dadaR <- dada(derepR,
                 err=errR,
		 multithread=FALSE,
		 OMEGA_A=opt$`omega-a`,
		 USE_QUALS=opt$`use-quals`,
		 USE_KMERS=opt$`use-kmers`,
		 KDIST_CUTOFF=opt$`kdist-cutoff`,
		 BAND_SIZE=opt$`band-size`,
		 GAP_PENALTY=opt$`gap-penalty`,
		 HOMOPOLYMER_GAP_PENALTY=opt$`homopolymer-ga-penalty`,
		 MIN_FOLD=opt$`min-fold`,
                 MIN_HAMMING=opt$`min-hamming`,
                 MIN_ABUNDANCE=opt$`min-abundance`,
		 MAX_CLUST=opt$`max-clust`,
		 MAX_CONSIST=opt$`max-consist`)

   # merge pairs - returns a dataframe
   flog.info("merging paired reads")
   mergers <- mergePairs(dadaF, derepF, dadaR, derepR, verbose=TRUE, propagateCol=c("n0", "n1", "nunq", "pval", "birth_type", "birth_pval", "birth_fold", "birth_ham", "birth_qave", "abundance"))


   # get diagnostic clustering data frame
   df.clustering <- data.frame(sequence=mergers$sequence,
                               F.abundance=mergers$F.abundance,
			       F.n0=mergers$F.n0,
                               F.n1=mergers$F.n1,
			       F.nunq=mergers$F.nunq,
			       F.pval=mergers$F.pval,
			       F.birth_pval=mergers$F.birth_pval,
			       F.birth_fold=mergers$F.birth_fold,
			       F.birth_ham=mergers$F.birth_ham,
			       F.birth_qave=mergers$F.birth_qave,
                               R.abundance=mergers$R.abundance,
                               R.n0=mergers$R.n0,
                               R.n1=mergers$R.n1,
			       R.nunq=mergers$R.nunq,
			       R.pval=mergers$R.pval,
			       R.birth_pval=mergers$R.birth_pval,
			       R.birth_fold=mergers$R.birth_fold,
			       R.birth_ham=mergers$R.birth_ham,
			       R.birth_qave=mergers$R.birth_qave)


   clustering.filename <- paste0(opt$`outdir`, "/", sample.name, "_clustering.tsv")
   write.table(df.clustering, clustering.filename, sep="\t", row.names=F, quote=F)

   mergers <- data.frame(sequence=mergers$sequence,
   	                 abundance=mergers$abundance,
			 forward=mergers$forward,
			 reverse=mergers$reverse,
			 nmatch=mergers$nmatch,
			 nmismatch=mergers$nmismatch,
			 nindel=mergers$nindel,
			 prefer=mergers$prefer,
			 accept=mergers$accept)

   flog.info("reoving sequences where accept==FALSE")
   # just keep accepted merged sequences
   mergers <- mergers[mergers$accept==TRUE,]

   # remove chimeras
   flog.info("removing chimeric sequences")
   mergers.nochim <- removeBimeraDenovo(mergers, method="consensus")

   # write out seq table
   flog.info("writing results")
   outfile <- paste(opt$`outdir`, sample.name, sep="/")
   outfile <- paste(outfile, "_seq_abundance.tsv", sep="")
   write.table(mergers.nochim, file=outfile, sep="\t", quote=F, row.names=F)
   
   # get summaries of reads passing each stage
   flog.info("writing summaries")
   getN <- function(x) sum(getUniques(x))
   track <- data.frame(cbind(getN(dadaF), getN(dadaR), getN(mergers), sum(mergers.nochim$abundance)))
   colnames(track) <- c("denoisedF", "denoisedR", "merged", "nonchim")
   track$sample <- sample.name

   summary.outfile <- paste(opt$`outdir`, sample.name, sep="/")
   summary.outfile <- paste(summary.outfile, "_summary.tsv", sep="")
   write.table(track, summary.outfile, sep="\t", row.names=F, quote=F)
}

###################################################
###################################################
# Filtering and trimming options for dada2
###################################################
###################################################

suppressPackageStartupMessages(library("optparse"))
suppressPackageStartupMessages(library("dada2"))
suppressPackageStartupMessages(library("futile.logger"))

# make options list
option_list <- list(
               make_option(c("-i", "--infile"), default=NA, type="character",
                           help="input fastq file [default %default]"),
               make_option(c("-f", "--filtered-directory"), default="filtered",
                           help="directory for filtered fastq files [default %default]"),
	       make_option(c("-p", "--paired"), action="store_true", default=FALSE,
                           help="is it paired-end data [default %default]"),
	       make_option(c("-n", "--maxN"), default=0,
                           help="maxN parameter [default %default]"),
               make_option(c("-e", "--maxEE"), default="2,2",
                           help="maximum number of expected errors [default %default]"),
               make_option(c("--truncQ"), default=2,
                           help="truncate reads at the first instance of a quality score less than or equal to truncQ [default %default]"),
               make_option(c("--truncLen"), default="250,250",
                           help="truncate  reads  after truncLen bases [default %default]"),
               make_option(c("--trimLeft"), default="0,0",
                           help="trim left sequence (primers) [default %default]"))


# suppress warning messages
options(warn=-1)

###########################
# get command line options
###########################
opt <- parse_args(OptionParser(option_list=option_list))

###########################
# helper functions
###########################

getInputFastq <- function(infile, paired){

	         if (paired){
		    fnF <- infile
		    fnR <- gsub(".fastq.1", ".fastq.2", fnF)}
		 else{
                    fnF <- infile
		    fnR <- NA}

		 return(list(fnF, fnR))
		 }

###########################
###########################
###########################

getSampleName <- function(fnF){

	       sample.name <- gsub(".fastq.1", "", basename(fnF))
	       return(sample.name)
	       }

###########################
###########################
###########################

splitArg <- function(arg){

	 # split input list argument
	 arg <- strsplit(arg, ",")
	 return(unlist(arg))
	 }
	 
###########################
###########################
###########################

# list options
truncLen <- as.numeric(splitArg(opt$`truncLen`))
maxEE <- as.numeric(splitArg(opt$`maxEE`))
trimLeft <- as.numeric(splitArg(opt$`trimLeft`))

# select input fastq files

input.files <- getInputFastq(opt$`infile`, opt$`paired`)

# input files
fnF <- unlist(input.files[1])
fnR <- unlist(input.files[2])

# sample names
sample.name <- getSampleName(fnF)

# filtering
filtF <- file.path(opt$`filtered-directory`, paste0(sample.name, ".fastq.1.gz"))

if (!(is.na(fnR))){
   filtR <- file.path(opt$`filtered-directory`, paste0(sample.name, ".fastq.2.gz"))
   }

flog.info(paste0("filtering reads and writing to ", opt$`filtered-directory`))
if (!(is.na(fnR))){

   out <- filterAndTrim(fnF, filtF, fnR, filtR,
                        truncLen=truncLen,
			trimLeft=trimLeft,
                        maxN=opt$`maxN`,
			maxEE=maxEE, truncQ=opt$`truncQ`, rm.phix=TRUE,
	                compress=TRUE, multithread=FALSE)
   flog.info(paste0(paste0("writing summary to ", opt$`filtered-directory`), "/summary.tsv"))
   out <- as.data.frame(out)
   out$sample <- sample.name
   outfile <- paste(opt$`filtered-directory`, sample.name, sep="/")
   outfile <- paste(outfile, "summary.tsv", sep="_")
   write.table(out, file=outfile, sep="\t", row.names=F, quote=F)
   }

if (is.na(fnR)){
   out <- filterAndTrim(fnF, filtF,
                        truncLen=truncLen,
			trimLeft=trimLeft,
                        maxN=opt$`maxN`,
			maxEE=maxEE, truncQ=opt$`truncQ`, rm.phix=TRUE,
	                compress=TRUE, multithread=FALSE)
   flog.info(paste0(paste0("writing summary to ", opt$`filtered-directory`), "/summary.tsv"))
   out <- as.data.frame(out)
   out$sample <- sample.name
   outfile <- paste(opt$`filtered-directory`, sample.name, sep="/")
   outfile <- paste(outfile, "summary.tsv", sep="_")
   write.table(out, file=outfile, sep="\t", row.names=F, quote=F)
   }

flog.info("DONE")

###################################################
###################################################
# Error model, de-replication and sample inference
###################################################
###################################################

suppressPackageStartupMessages(library("optparse"))
suppressPackageStartupMessages(library("dada2"))
suppressPackageStartupMessages(library("futile.logger"))
suppressPackageStartupMessages(library("dplyr"))

# make options list
option_list <- list(
               make_option(c("--seqfile"),
                           help="file with sequence and abundance"),
               make_option(c("--training-set"),
                           help="training set for assigning taxonomy"),
               make_option(c("--species-file"),
                           help="file for assigning at the species level"),
               make_option(c("-o", "--outfile"),
                           help="outfile containing taxa and abundances")
			   )

# suppress warning messages
options(warn=-1)

###########################
# get command line options
###########################

opt <- parse_args(OptionParser(option_list=option_list))

# read sequence to abundance file
seqs <- read.csv(opt$`seqfile`, header=T, stringsAsFactors=F, sep="\t")

# assign taxonomy
flog.info("assigning taxonomy")
taxa <- assignTaxonomy(seqs, opt$`training-set`)

# add species
flog.info("adding species assignments")
taxa <- addSpecies(taxa, opt$`species-file`)
taxa <- as.data.frame(unlist(taxa))

# merge the data
flog.info("merging data")
all.data <- merge(taxa, seqs, by.x="row.names", by.y="sequence", all.x=T, all.y=T)
colnames(all.data) <- gsub("Row.names", "sequence", colnames(all.data))

# write data
flog.info("writing output")
write.table(all.data, file=opt$`outfile`, sep="\t", quote=F, row.names=F)

suppressPackageStartupMessages(library("optparse"))
library(rmarkdown)

option_list <- list(
               make_option(c("-i", "--infile"), default=NA, type="character",
                           help="input fastq file [default %default]"))

# suppress warning messages
options(warn=-1)

###########################
# get command line options
###########################
opt <- parse_args(OptionParser(option_list=option_list))

render(opt$`infile`, output_format="html_document")

---
title: "diagnostics"
header-includes: #allows you to add in your own Latex packages
- \usepackage{float} #use the 'float' package
- \floatplacement{figure}{H} #make every figure with caption = h

output:
  pdf_document:
    fig_caption: true
    keep_tex: true
    latex_engine: pdflatex
  html_document:
    df_print: paged
urlcolor: blue

graphics: yes
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_chunk$set(cache = FALSE)
knitr::opts_chunk$set(warning = FALSE)
knitr::opts_chunk$set(out.extra = '')
#knitr::opts_chunk$set(fig.pos = 'H')
knitr::opts_knit$set(root.dir = "../abundance.dir")
```

# Error models

Although we output a representative error model plot in the main report, here we produce one per sample.

```{r error.model, results = 'asis'}
plots <- list.files(pattern="../filtered.dir/*.png")
for(i in plots){
    filename <- file.path("plot", i)
    cat("![text](",filename,")")
}
```

# Dada2 diagnostics

Dada2 outputs some useful diagnostics metrics for ASVs that are included in the clustering data frame. Here we plot these
for each sample in order to provide some way of determining how good the ASV calls are. The columns that we use are:

* (n0 + n1)/abundance - This provides the abundance of exact matching and one-away matches per partition (2-columns for paired data)
* birth_pval - p-value associated with the confidence in creating a new partition
* birth_ham - hamming distance of new partition from partition that it was separated from
* birth_qave - average quality score of variants that separate this partition from the partition that it separated from


```{r diagnostics, fig.cap='Diagnostic plots', fig.height=5, fig.width=10,  echo=FALSE, message=FALSE}

library(GGally)
library(gridExtra)
infiles <- list.files(pattern="*_clustering.tsv")

grob.list = list()
for (i in 1:length(infiles)){
    dat <- read.csv(infiles[i], header=T, stringsAsFactors=F, sep="\t", row.names=1)
    if ("F.n0" %in% colnames(dat)){
        paired=TRUE}
    else{
        paired=FALSE}
    if (paired==FALSE){
        d <- data.frame(fone.away=(dat$n0 + dat$n1)/dat$abundance,
	                birth_pval=-log10(dat$birth_pval),
			birth_ham=dat$birth_ham,
			birth_qave=dat$birth_qave)
        print(ggpairs(d) + theme_bw() + ggtitle(infiles[i]))
        
    }
    else{
        F.d <- data.frame(F.fone.away=(dat$F.n0 + dat$F.n1)/dat$F.abundance,
	                F.birth_pval=-log10(dat$F.birth_pval),
			F.birth_ham=dat$F.birth_ham,
			F.birth_qave=dat$F.birth_qave)
        R.d <- data.frame(R.fone.away=(dat$R.n0 + dat$R.n1)/dat$R.abundance,
	                R.birth_pval=-log10(dat$R.birth_pval),
			R.birth_ham=dat$R.birth_ham,
			R.birth_qave=dat$R.birth_qave)
        print(ggpairs(F.d) + theme_bw() + ggtitle(infiles[i]))
        print(ggpairs(R.d) + theme_bw() + ggtitle(infiles[i]))
    }
}

	

```

---
title: "dada2 processing report"
header-includes:
- \usepackage{placeins}
- \usepackage{float}
- \floatplacement{figure}{H}

output:
  html_document:
    df_print: paged
urlcolor: blue
---

\newpage

```{r child = 'pipeline_dada2.Rmd'}
```

---
header-includes: #allows you to add in your own Latex packages
- \usepackage{float} #use the 'float' package
- \floatplacement{figure}{H} #make every figure with caption = h

output:
  pdf_document:
    fig_caption: true
    keep_tex: true
    latex_engine: pdflatex
  html_document:
    df_print: paged
urlcolor: blue

graphics: yes
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_chunk$set(cache = FALSE)
knitr::opts_chunk$set(warning = FALSE)
knitr::opts_chunk$set(out.extra = '')
#knitr::opts_chunk$set(fig.pos = 'H')
knitr::opts_knit$set(root.dir = "../")
```

## dada2 filtering reads

The first stage of the dada2 pipeline is filtering and trimming of reads. The number of reads
that remain for downstream analysis is dependent on the parameters that were set for filtering
and trimming. In most cases it would be expected that the vast majority of reads will remain
after this step. It is noteworthy that dada2 does not accept any "N" bases and so will remove
reads if there is an N in the sequence.

```{r include=FALSE, echo=FALSE}
library(ggplot2)
library(plotly)
library(gridExtra)
library(dplyr)
library(reshape)
library(gplots)
library(data.table)
```

### Number of reads input/output during filtering and trimming

Below is a summary of the number of input reads and the number of output reads for each sample.

```{r filtering, fig.cap='Number of input and output reads during filtering step', fig.height=4, fig.width=10,  echo=FALSE, message=FALSE}

#########################
# read relevant infiles
#########################

infiles = list.files(path="filtered.dir", pattern = "*summary.tsv")

###########################################
# create dataframe from all summary tables
###########################################

dfs <- list()
names.list <- c()
for (i in 1:length(infiles)){
    infile <- paste("filtered.dir", infiles[i], sep="/")
    df <- read.csv(infile, header=T, stringsAsFactors=F, sep="\t")
    dfs[[i]] <- df
    names.list <- append(basename(infile), names.list)
}
names(dfs) <- names.list
df <- bind_rows(dfs)

################################################
# define reads.in as the difference between the
# starting number and the finishing number. This
# enables visualisation in a stacked bar chart
################################################

df$reads.in <- df$reads.in - df$reads.out

# reshape and plot
df.m <- melt(df)

p1 <- ggplot(df.m, aes(x=reorder(sample, as.numeric(sample)), y=value, fill=variable))
p2 <- p1 + geom_bar(stat="identity")
p3 <- p2 + scale_fill_manual(values=c("red4", "blue4"))
p4 <- p3 + theme_bw() + theme(axis.text.x=element_text(angle=90)) + xlab("sample") + ylab("Number of reads")
ggplotly(p=p4)

```

## Learning the error model

Dada2 performs a step where it learns the sequencing error model. Taken from the tutorial:

The DADA2 algorithm makes use of a parametric error model (err) and every amplicon dataset has a different set of error rates.
The learnErrors method learns this error model from the data, by alternating estimation of the error rates and inference of sample
composition until they converge on a jointly consistent solution. As in many machine-learning problems, the algorithm must begin
with an initial guess, for which the maximum possible error rates in this data are used (the error rates if only the most abundant
sequence is correct and all the rest are errors).

In contrast to the dada2 tutorial [here](https://benjjneb.github.io/dada2/tutorial.html), and for the purposes of parallelisation,
we learn the error model using each sample separately. It should be noted that this may not be ideal in all situtations but it does
speed up data processing. This also means that we produce a plot for each sample separately. It is not feasible to display them
all here and so we just inspect one for the report purposes but all others are available where the piepline was run. Note that
at the moment this is restricted to the forward reads (so there is no error thrown when using single end data).


![Error model](errF.png)

## De-replication, sample inference, merging and chimera removal

The next stage of the dada2 pipeline involves dereplication, sample inference, merging (if paired-end) and chimera removal.
Again from the tutorial, dereplication combines all identical sequencing reads into into “unique sequences” with a corresponding
“abundance” equal to the number of reads with that unique sequence. These are then taken forward into the sample inference stage
and chimera removal. It is useful to see after this has been done how many sequences we are left with. The majority of reads
should contribute to the final overall counts.


```{r sample-inference, fig.cap='Number of input and output reads during filtering step', fig.height=8, fig.width=8,  echo=FALSE, message=FALSE}

#########################
# read relevant infiles
#########################

infiles = list.files(path="abundance.dir", pattern = "*summary.tsv")

###########################################
# create dataframe from all summary tables
###########################################

dfs <- list()
names.list <- c()
for (i in 1:length(infiles)){
    infile <- paste("abundance.dir", infiles[i], sep="/")
    df <- read.csv(infile, header=T, stringsAsFactors=F, sep="\t")
    dfs[[i]] <- df
    names.list <- append(basename(infile), names.list)
}
names(dfs) <- names.list
df <- bind_rows(dfs)

# reshape and plot
df.m <- melt(df)

p1 <- ggplot(df.m, aes(x=reorder(sample, as.numeric(sample)), y=value))
p2 <- p1 + geom_bar(stat="identity")
p3 <- p2 + theme_bw() + theme(axis.text.x=element_text(angle=90)) + xlab("sample") + ylab("Number of reads")
p4 <- p3 + facet_wrap(~variable)
ggplotly(p=p4)

```

## Number of ASVs called per sample and their prevalence

A useful metric is the number of ASVs that were called per sample even though we may not no beforehand the expected diversity in the samples we are analysing. In addition to simply counting the number of ASVs per sample we also plot the prevalence of these ASVs i.e. the proportion of samples that each ASV is observed in. By plotting the prevalence against the average relative abundance we get an idea of the presence of suprious ASVs i.e. low prevalence and low abundance.

```{r nasvs, fig.height=4, fig.width=10,  echo=FALSE, message=FALSE}

# read ASV counts and reformat
dat <- data.frame(fread("abundance.dir/taxa_abundances.tsv", header=TRUE, stringsAsFactors=F, sep="\t"))
rownames(dat) <- dat$featureID
dat <- dat[,2:ncol(dat)]

nasvs <- data.frame(colSums(dat > 0))
nasvs$sample <- factor(rownames(nasvs), levels=unique(rownames(nasvs)))
nasvs.m <- melt(nasvs)

# number of ASVs
p1 <- ggplot(nasvs.m, aes(x=reorder(sample, as.numeric(sample)), y=value))
p2 <- p1 + geom_bar(stat="identity")
p3 <- p2 + theme_bw()
p4 <- p3 + theme(axis.text.x=element_text(angle=90))
p5 <- p4 + ylab("number of ASVs")
ggplotly(p5)
```

```{r prevalence, fig.height=4, fig.width=10, echo=FALSE, message=FALSE}

# Functions lifted from AmpSeqKit - this will be a package in the future

###############
###############
###############

# prevalence
pprev <- function(counts){

    nsamples <- ncol(counts)
    prev <- (rowSums(counts > 0)/nsamples)*100
    prev.df <- data.frame(Taxon=rownames(counts), Prevalence=prev)
    return(prev.df)
    }

###############
###############
###############

# plotting
plotPrev <- function(prev.df, as.is=TRUE){

    if (as.is==TRUE){
        prev.df <- prev.df[order(prev.df$Prevalence, decreasing=TRUE),]
        p1 <- ggplot(prev.df, aes(x=Taxon, y=Prevalence))
        p2 <- p1 + geom_bar(stat="identity")
        p3 <- p2 + theme_bw()
        p4 <- p3 + theme(axis.text.x=element_text(angle=90))
    }else{
        p1 <- ggplot(prev.df, aes(x=Prevalence))
        p2 <- p1 + geom_histogram()
        p3 <- p2 + theme_bw()
        p4 <- p3
    }
    return(p4)
}

# calculate and plot histogram of prevalence
prev <- pprev(dat)
p6 <- plotPrev(prev, as.is=FALSE)

# relative abundance
relab <- function(counts){

    relab <- (sweep(counts, 2, colSums(counts), "/"))*100
    return(relab)
    }

# plot abundance vs. prevalence
ave.abundance <- rowMeans(relab(dat))
prev$abundance <- ave.abundance

p7 <- ggplot(prev, aes(x=abundance, y=Prevalence))
p8 <- p7 + geom_point()
p9 <- p8 + theme_bw()
p10 <- p9 + xlab("Mean relative abundance") + ylab("Prevalence (%)")

subplot(ggplotly(p=p6), ggplotly(p=p10), nrows=1)

```

## Taxonomic assignment

The next stage is to assign each of the amplicon sequence variants (ASV) to a taxonomic group. Below are plots of the taxonomic assignments for each sample (relative abundance at the phylum level) as well as the proportion of all ASVs that could be assigned at each taxonomic rank (phylum-species). We would expect (in most cases) that the majority of ASVs woild be assigned at high taxonomic ranks (e.g. phylum) and fewer at lower taxonomic ranks (e.g. species).


```{r taxonomy, fig.height=4, fig.width=10,  echo=FALSE, message=FALSE}

# taxonomic distributions
# phylum level only for visualisation purposes

p <- gsub(";c__.*", "", rownames(dat))
p <- gsub("ASV[0-9]*:k__[a-zA-Z]+;", "", p)
dp <- melt(aggregate(dat, list(p), sum))

# again lifted from AmpSeqKit.
plotBar <- function(x){
	p1 <- ggplot(x, aes(x=variable, y=value, fill=Group.1))
	p2 <- p1 + geom_bar(position="fill", stat="identity")
	p3 <- p2 + scale_y_continuous(labels = scales::percent)
	p4 <- p3 + theme_bw()
	p5 <- p4 + theme(axis.text.x=element_text(angle=90)) + ylab("% of reads")
	return(p5)
	}

# plot phylum level distributions
p11 <- plotBar(dp)
ggplotly(p11)
```

```{r nreads.in.taxa, fig.height=4, fig.width=5, echo=FALSE, message=FALSE}

# Plot number of asvs assigned at each level

taxonomy.abundances <- list.files(path="taxonomy_abundances.dir", pattern="*.tsv")
nasvs.assigned <- list()

for (i in 1:length(taxonomy.abundances)){
    dir <- "taxonomy_abundances.dir"
    inf <- taxonomy.abundances[i]
    tfile <- paste0(dir, "/", inf)
    abundances <- read.csv(tfile, header=T, stringsAsFactors=F, sep="\t", quote="", row.names=1)
    # get the first letter of file which is level
    level <- substr(inf, 1, 1)
    level.na <- paste0(level, "__", "NA")
    nhit <- nrow(abundances[grep(level.na, rownames(abundances), invert=TRUE),])
    n <- nrow(abundances)
    level <- unlist(strsplit(inf, "_"))[1]
    nassigned <- data.frame(percent.assigned=(nhit/n)*100, level=level)
    nasvs.assigned[[i]] <- nassigned
}
nasvs.assigned <- bind_rows(nasvs.assigned)
nasvs.assigned$level <- factor(nasvs.assigned$level, levels=c("phylum", "class", "order", "family", "genus", "species"))
p12 <- ggplot(nasvs.assigned, aes(x=level, y=percent.assigned, fill=level))
p13 <- p12 + geom_bar(stat="identity")
p14 <- p13 + theme_bw() 
p15 <- p14 + ylab("% assigned") + xlab("Taxonomic levels")
p16 <- p15 + scale_fill_manual(values=c("red3", "blue3", "green3", "orange3", "purple3", "grey", "black"))
ggplotly(p16)
```
